module cmos_8_16(
	input pclk,
	input rst_n,
	input [7:0] data_i,
	input Init_Done,
	input cmos_vsync,
	input href,
	output reg fifo_aclr,
	output reg [15:0] data_o,
	output reg de
);
	reg [7:0] data_i_r;
	always @ (posedge pclk)
	begin
		data_i_r <= data_i;
	end
	
	reg [15:0] v_cnt;
	always @ (posedge pclk or negedge rst_n)
	begin
		if (!rst_n)
			v_cnt <= 'd0;
		else if (href)
			v_cnt <= v_cnt + 1'b1;
		else
			v_cnt <= 'd0;
	end
	
	always @ (posedge pclk or negedge rst_n)
	if (!rst_n)
		fifo_aclr <= 1'b1;
	else if (Init_Done && cmos_vsync) //等到初始化摄像完成且头场同步信号出现，释放清零信号，开始写入数据
		fifo_aclr <= 1'b0;
	else
		fifo_aclr <= fifo_aclr;
	
	always @ (posedge pclk or negedge rst_n)
	begin
		if (!rst_n)
			data_o <= 'd0;
		else if (href && v_cnt[0])
			data_o <= {data_i_r, data_i};
	end
	
	always @ (posedge pclk or negedge rst_n)
	begin
		if (!rst_n)
			de <= 1'b0;
		else if (href && v_cnt[0])
			de <= 1'b1;
		else
			de <= 1'b0;
	end
	
endmodule
